INCOM_outUnit = function(forUnit,outText,outTime) -- function outputs text using the mist message system

	if outText and outTime then
		local msg = {}
		msg.text = outText
		msg.displayTime = outTime
		msg.msgFor = {units = {forUnit}}
		msg.sound = 'incoming.wav'
		mist.message.add(msg)
	end
end

INCOM_incoming = function(coa,event)
local playerName,playerUnit,playerPosition
local counter
local weapon
local position
local playerPosition,playerHeading,relativePosition,playerHeading,headingVector,headingVectorPerpendicular,forwardDistance,rightDistance,angle
local text

	weapon = event.weapon
	if Weapon.isExist(weapon) then
		playerName = 'Player' -- get name of player
		playerUnit = Unit.getByName(playerName) -- get player unit
		if playerUnit then -- is client alive?
			position = Weapon.getPosition(weapon).p
			playerPosition = Unit.getPosition(playerUnit).p
			relativePosition = mist.vec.sub(position,playerPosition)
			if mist.vec.mag(relativePosition) < 10000 then
				playerHeading = mist.getHeading(Unit.getByName(playerName)) 
				headingVector = {x = math.cos(playerHeading),y=0,z=math.sin(playerHeading)}
				headingVectorPerpendicular = {x = math.cos(playerHeading+math.pi/2),y=0,z=math.sin(playerHeading+math.pi/2)}
				forwardDistance = mist.vec.dp(relativePosition,headingVector)
				rightDistance = mist.vec.dp(relativePosition,headingVectorPerpendicular)
				angle = math.atan2(rightDistance,forwardDistance)*180/math.pi
				if angle < 0 then
					angle = 360+angle
				end
				angle = math.floor(angle*12/360+0.5)
				if angle == 0 then
					angle = 12
				end
				text = '[copilot] Incoming ' .. angle .. ' oclock'
				INCOM_outUnit(playerName,text,1)
			end
		end
		HOVER_deepSchedule(INCOM_incoming,{coa,event},timer.getTime()+1)
	end
end

customEventHandler = {} -- this creates the event handler for pilot ejection

function customEventHandler:onEvent(event)
local unitDown
local coa

	if event.id == world.event.S_EVENT_SHOT and string.sub(Unit.getName(event.initiator),1,7) == 'MANPADS' then
		if Unit.getCoalition(event.initiator) == coalition.side.RED then
			coa = 'blue'
		else
			coa = 'red'
		end
		-- out(coa,mist.utils.serialize('event',event), 10)
		HOVER_deepSchedule(INCOM_incoming,{coa,event},timer.getTime()+0.5)
	end
end

world.addEventHandler(customEventHandler) -- initialize event handler
